/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumCalculated;
import de.ship.db.tables.TCoreVariable.TCoreVariablePath;
import de.ship.db.tables.records.TDmCalculatedRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmCalculated extends TableImpl<TDmCalculatedRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_calculated</code>
     */
    public static final TDmCalculated T_DM_CALCULATED = new TDmCalculated();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmCalculatedRecord> getRecordType() {
        return TDmCalculatedRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_calculated.lastchange</code>.
     */
    public final TableField<TDmCalculatedRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_calculated.fk_variable</code>. ID of
     * variable
     */
    public final TableField<TDmCalculatedRecord, Integer> FK_VARIABLE = createField(DSL.name("fk_variable"), SQLDataType.INTEGER.nullable(false), this, "ID of variable");

    /**
     * The column <code>common_dd.t_dm_calculated.calc_tool</code>. calculation
     * tool
     */
    public final TableField<TDmCalculatedRecord, EnumCalculated> CALC_TOOL = createField(DSL.name("calc_tool"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(EnumCalculated.class), this, "calculation tool");

    /**
     * The column <code>common_dd.t_dm_calculated.calc_order</code>. order of
     * calculating
     */
    public final TableField<TDmCalculatedRecord, Integer> CALC_ORDER = createField(DSL.name("calc_order"), SQLDataType.INTEGER, this, "order of calculating");

    /**
     * The column <code>common_dd.t_dm_calculated.fk_tabledef</code>. variable
     * reference (key_variable) for this adding
     */
    public final TableField<TDmCalculatedRecord, Integer> FK_TABLEDEF = createField(DSL.name("fk_tabledef"), SQLDataType.INTEGER.nullable(false), this, "variable reference (key_variable) for this adding");

    private TDmCalculated(Name alias, Table<TDmCalculatedRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmCalculated(Name alias, Table<TDmCalculatedRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_calculated</code> table reference
     */
    public TDmCalculated(String alias) {
        this(DSL.name(alias), T_DM_CALCULATED);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_calculated</code> table reference
     */
    public TDmCalculated(Name alias) {
        this(alias, T_DM_CALCULATED);
    }

    /**
     * Create a <code>common_dd.t_dm_calculated</code> table reference
     */
    public TDmCalculated() {
        this(DSL.name("t_dm_calculated"), null);
    }

    public <O extends Record> TDmCalculated(Table<O> path, ForeignKey<O, TDmCalculatedRecord> childPath, InverseForeignKey<O, TDmCalculatedRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_CALCULATED);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmCalculatedPath extends TDmCalculated implements Path<TDmCalculatedRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmCalculatedPath(Table<O> path, ForeignKey<O, TDmCalculatedRecord> childPath, InverseForeignKey<O, TDmCalculatedRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmCalculatedPath(Name alias, Table<TDmCalculatedRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmCalculatedPath as(String alias) {
            return new TDmCalculatedPath(DSL.name(alias), this);
        }

        @Override
        public TDmCalculatedPath as(Name alias) {
            return new TDmCalculatedPath(alias, this);
        }

        @Override
        public TDmCalculatedPath as(Table<?> alias) {
            return new TDmCalculatedPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public UniqueKey<TDmCalculatedRecord> getPrimaryKey() {
        return Keys.PK_DM_CALCULATED;
    }

    @Override
    public List<ForeignKey<TDmCalculatedRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_CALCULATED__FK_DM_CALCULATED_VARIABLE);
    }

    private transient TCoreVariablePath _tCoreVariable;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_variable</code>
     * table.
     */
    public TCoreVariablePath tCoreVariable() {
        if (_tCoreVariable == null)
            _tCoreVariable = new TCoreVariablePath(this, Keys.T_DM_CALCULATED__FK_DM_CALCULATED_VARIABLE, null);

        return _tCoreVariable;
    }

    @Override
    public TDmCalculated as(String alias) {
        return new TDmCalculated(DSL.name(alias), this);
    }

    @Override
    public TDmCalculated as(Name alias) {
        return new TDmCalculated(alias, this);
    }

    @Override
    public TDmCalculated as(Table<?> alias) {
        return new TDmCalculated(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmCalculated rename(String name) {
        return new TDmCalculated(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmCalculated rename(Name name) {
        return new TDmCalculated(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmCalculated rename(Table<?> name) {
        return new TDmCalculated(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmCalculated where(Condition condition) {
        return new TDmCalculated(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmCalculated where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmCalculated where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmCalculated where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmCalculated where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmCalculated where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmCalculated where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmCalculated where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmCalculated whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmCalculated whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
